use test;
begin;

-- drop tables, in reverse order not to break fk constraints

drop table if exists message;
drop table if exists role;
drop table if exists party;

-- ------------------------------------------------------------
-- the table of people who can log into the site
create table party (
	uid integer not null auto_increment,
	login varchar(255) unique not null, -- the email (username) entered into the site
	password varchar(255) not null, -- the password
    primary key (uid),
    index (login)
) type = innodb;

-- ------------------------------------------------------------
-- create a table for holding the roles of users/customers/staff. 
create table role (
	uid integer not null auto_increment,
	login varchar(50) not null,
	role varchar(50) not null,
	primary key (uid),
    foreign key (login) references party(login),
    index (login)
) type = innodb;

-- ------------------------------------------------------------
-- create a table for holding the messages which this system manages 
create table message (
	uid integer not null auto_increment,
	sender varchar(50) not null,
	when_sent datetime not null,
	status varchar(20) not null,
	primary key (uid),
    foreign key (sender) references party(login)
) type = innodb;

commit;
