package uk.co.maxant.test;

import java.util.List;

import javax.ejb.Schedule;
import javax.ejb.Stateless;
import javax.ejb.Timer;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;

@Stateless
@TransactionManagement(TransactionManagementType.CONTAINER)
public class EJBTimerSeven {

	@PersistenceContext(unitName="MessageManagement")
	private EntityManager em;

    public EJBTimerSeven() {
    }
	
    /**
     * processes all new messages
     */
	@SuppressWarnings("unused")
	@Schedule(second="0", minute="*/1", hour="6-23", dayOfWeek="Mon-Fri", dayOfMonth="*", month="*", year="*", info="MyTimer")
	@TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
    private void scheduledTimeout(final Timer t) {
		long start = System.currentTimeMillis();
        System.out.println("@Schedule called at: " + new java.util.Date());
        
        String criteriaQuery;
		TypedQuery<Message> q = em.createQuery(
				"select m " +
				"from Message m " +
				"where m.status = :status", Message.class);
		q.setParameter("status", Status.NEW.toString());
		
		List<Message> msgs = q.getResultList();
		for(Message m : msgs){
			System.out.println("processing message " + m.getUid());
			m.setStatus(Status.PROCESSED.toString());
		}
		System.out.println("schedule finished in " + (System.currentTimeMillis() - start) + " ms");
    }
}