package uk.co.maxant.test;

import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;
import javax.mail.Address;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

/**
 * Message-Driven Bean implementation class for: MDBean
 *
 */
@MessageDriven(
		activationConfig = { @ActivationConfigProperty(
				propertyName = "destinationType", propertyValue = "javax.jms.Queue"
		) }, 
		mappedName = "jms/destinationResource")
public class MDBean implements MessageListener {

	public static final String FROM = "_from";

	@Resource(name="mail/Session")
	private Session mailSession;
	
    public MDBean() {
    }
	
	/**
     * @see MessageListener#onMessage(Message)
     */
    public void onMessage(Message msg) {
    	TextMessage tm = (TextMessage) msg;
    	try{
    		String text = tm.getText();
    		System.out.println("i got a message: " + text);
    		
    		  Address[] adds = new InternetAddress[1];
    		  adds[0] = new InternetAddress("asdf23@maxant.co.uk");
    		  javax.mail.Message mmsg = new MimeMessage(mailSession);
    		  mmsg.setText("message from " + tm.getStringProperty(FROM) + ": " + text);
    		  Transport.send(mmsg, adds);
    		
    	}catch(JMSException e){
    		//ideally handle with some kind of error handler which notifies someone
    		//or puts this in a DLQ so it can be processed at another time.
    		e.printStackTrace();
    	} catch (MessagingException e) {
    		//ideally handle with some kind of error handler which notifies someone
    		//or puts this in a DLQ so it can be processed at another time.
			e.printStackTrace();
		}
    }

}
