package uk.co.maxant.test;

import java.io.IOException;

import javax.annotation.Resource;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.annotation.WebServlet;

/**
 * Servlet implementation class SevenServlet
 */
@WebServlet(name = "SevenServlet", urlPatterns = { "/SevenServlet" })
public class SevenServlet extends HttpServlet {

	private static final long serialVersionUID = 1L;

	public static final String RESULT = "_result";

	/**
	 * the following is a local bean and can be accessed either using the @EJB
	 * annotation, or using the @Resource annotation, as shown below.
	 * the "java:app" part means its deployed as part of this app, in the 
	 * SevenEJB module and has the name EJBSeven.
	 * notice how we have a reference to the beans interface and not impl.
	 */
	@Resource(name="java:app/SevenEJB/EJBSeven")
	private EJBSevenLocal ejbLocal;

	/**
	 * to access a remote bean we just use the @EJB annotation.
	 * theoretically this should also work:
	 * 
	 *   @Resource(name="java:global/Seven/SevenEJB/EJBSeven2")
	 *   
	 * but for some reason it doesnt!
	 * notice how we have a reference to the beans interface and not impl.
	 */
	//@EJB
	//private EJBSevenRemote ejbRemote;
	
    /**
     * @see HttpServlet#HttpServlet()
     */
    public SevenServlet() {
        super();
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	/**
	 * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
	 * @param request servlet request
	 * @param response servlet response
	 * @throws ServletException if a servlet-specific error occurs
	 * @throws IOException if an I/O error occurs
	 */
	protected void processRequest(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {

		response.setContentType("text/html;charset=UTF-8");
		String command = "asdf";
		String p = request.getParameter("error");
		if(p != null){
			if(p.equals("true")){
				command = "fdsa";
			}
		}
		request.setAttribute(RESULT, ejbLocal.execute(command));
		
		//finished the logic (controller), now for the presentation
		request.getRequestDispatcher("/servletResult.jsp").forward(request, response);
	}

}
